unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, System.Rtti,
  FMX.Grid.Style, FMX.Memo.Types, Data.Bind.Controls, FireDAC.Stan.Intf,
  FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf,
  FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys,
  FireDAC.Phys.SQLite, FireDAC.Phys.SQLiteDef, FireDAC.Stan.ExprFuncs,
  FireDAC.Phys.SQLiteWrapper.Stat, FireDAC.FMXUI.Wait, FireDAC.Stan.Param,
  FireDAC.DatS, FireDAC.DApt.Intf, FireDAC.DApt, Data.Bind.EngExt,
  Fmx.Bind.DBEngExt, Fmx.Bind.Grid, System.Bindings.Outputs, Fmx.Bind.Editors,
  Data.Bind.Components, Data.Bind.Grid, Data.Bind.DBScope, FireDAC.Comp.Client,
  Data.DB, FireDAC.Comp.DataSet, FireDAC.Comp.QBE, Fmx.Bind.Navigator, FMX.Grid,
  FMX.Memo, FMX.StdCtrls, FMX.Layouts, FMX.Controls.Presentation, FMX.ScrollBox;

type

  TForm1 = class(TForm)
    FDConnection1: TFDConnection;
    FDQBE1: TFDQBE;
    FDQuery1: TFDQuery;
    DataSource1: TDataSource;
    FDMemTable1: TFDMemTable;
    DataSource2: TDataSource;
    Grid1: TGrid;
    Layout1: TLayout;
    Memo1: TMemo;
    btnEdit: TButton;
    BindSourceDB1: TBindSourceDB;
    BindingsList1: TBindingsList;
    BindSourceDB2: TBindSourceDB;
    LinkGridToDataSourceBindSourceDB1: TLinkGridToDataSource;
    Grid2: TStringGrid;
    BindNavigator1: TBindNavigator;
    LinkGridToDataSourceBindSourceDB2: TLinkGridToDataSource;
    btnSave: TButton;
    procedure btnEditClick(Sender: TObject);
    procedure BindNavigator1Click(Sender: TObject; Button: TBindNavigateBtn);
    procedure btnSaveClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure FillMemo;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

uses FMX.Objects;

procedure TForm1.BindNavigator1Click(Sender: TObject; Button: TBindNavigateBtn);
begin
case button of
  nbInsert: begin
     TBindSourceDB(TBindNavigator(Sender).DataSource).Dataset.append;  { You want to append }
     Abort;
     end;
  nbDelete,nbPost:
   begin
    inherited;
    FDQBE1.Edit;
    FDQBE1.Post;
    FillMemo;
   end;
  nbRefresh  :
    begin
      Memo1.Lines.Clear;
      FDQBE1.Cancel ;
      FDQBE1.Edit;
    end;
end;
end;

procedure TForm1.btnEditClick(Sender: TObject);
begin
FDquery1.Open();
FDQBE1.Edit;
Memo1.Lines.Clear;
end;

procedure TForm1.btnSaveClick(Sender: TObject);
var aStream : TMemoryStream;
begin
aStream:=TMemoryStream.Create;
try
fdQBE1.SaveToStream(aStream);
aStream.Position:=0;
memo1.Lines.LoadFromStream(aStream);
finally
  aStream.Free;
end;
end;

procedure TForm1.FillMemo;
begin
    Memo1.Lines.Clear;
    Memo1.Lines.Add('------QBE ----------------------');
    Memo1.Lines.AddStrings(FDQBE1.SQL);
    Memo1.Lines.Add('------ FDQuery----------------------');
    Memo1.Lines.AddStrings(FDQuery1.SQL);
end;



end.
